#include <inc\reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <rtx51.h>

#define WaitForEver 0xFF

#define MBXS    7

#define SYSTEM  0
#define CLOCK   1

typedef xdata struct
{
 unsigned char Hod,Min,Sek;
 int ADC;
 float Voltage;
// unsigned int *AddrBlock;                                           //Ukazujem na adresu bloku v pool-e ...
}Time;


//----------------------------------------------------------------
#define NumMemBlocks	2	                                        //Definujem n pamatovych blokov ...
#define	SizeMemBlock	sizeof(Time)
#define	SizeMemPool		NumMemBlocks*(2+SizeMemBlock+1)
//----------------------------------------------------------------
xdata unsigned char Pool[SizeMemPool];								//POOL je niekedy lepsie definovat na pevnej adrese ale uVision robi problemy pri simulacii ...
xdata Time Cas = {6,15,55};
xdata Time *ReceivedMessage;	    								//Adresa struktury prijatej spravy ...
xdata unsigned int *MessageToSend;									//Adresa struktury vysielanej spravy ...
//----------------------------------------------------------------

void Clock(void) _task_ CLOCK _priority_ 0
{
 signed char RtxCompletion;
 unsigned int *Ptr;
 RtxCompletion=os_create_pool(SizeMemBlock,Pool,SizeMemPool);           //OK=0, NOT_OK=-1
 while(1)
  {
   RtxCompletion=os_wait(K_TMO,100,NULL);
   if(++Cas.Sek==60)
    {
     Cas.Sek=0;
     if(++Cas.Min==60)
      {
       Cas.Min=0;
       if(++Cas.Hod==24)
        {
         Cas.Hod=0;
        } 
      }
    } 
/*    if((Cas.AddrBlock=os_get_block(SizeMemBlock))!=NULL)                //Pridelim blok pamati ... vysledok nesmie byt OK<>NULL
     {
      Ptr=memcpy(Cas.AddrBlock,&Cas,sizeof(Cas));                       //Skopirujem do pridelenej pamati strukturu ...
      RtxCompletion=os_send_message(MBXS,(unsigned int)Cas.AddrBlock,WaitForEver);
      RtxCompletion=os_free_block(SizeMemBlock,Cas.AddrBlock);          //Uvolnim prideleny blok pamati .... OK=NULL
     }*/
    if((MessageToSend=os_get_block(SizeMemBlock))!=NULL)                //Pridelim blok pamati ... vysledok nesmie byt OK<>NULL
     {
      Ptr=memcpy(MessageToSend,&Cas,sizeof(Cas));                       //Skopirujem do pridelenej pamati strukturu ...
      RtxCompletion=os_send_message(MBXS,(unsigned int)MessageToSend,WaitForEver);
      RtxCompletion=os_free_block(SizeMemBlock,MessageToSend);          //Uvolnim prideleny blok pamati .... OK=NULL
     }
  }
}

void System(void) _task_ SYSTEM _priority_ 0
{
 signed char RtxCompletion;
 unsigned char Hod,Min,Sek;
 RtxCompletion=os_set_slice(15360);
 RtxCompletion=os_create_task(CLOCK);
 while(1)
  {
   switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+MBXS,WaitForEver,(unsigned int xdata*)&ReceivedMessage))
    {
     case   TMO_EVENT   :   break;
     case   MSG_EVENT   :   Sek=ReceivedMessage->Sek; Min=ReceivedMessage->Min; Hod=ReceivedMessage->Hod;
                            break;
    }
  }
}

void main(void)
{
 signed char RtxCompletion;
 RtxCompletion=os_start_system(SYSTEM);
}